/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package JSTL_WS_package;

import java.util.Random;
import java.util.logging.Logger;

/**
 *
 * @author damienl
 */
class GRASP extends Methods implements Runnable  {
        
        private Probleme un_probleme;
        private Solution best_solution;
        private Random r;
        private int indiceC;
        private int nbMaxVect;
        private int nbMaxDeplacement;
        private int nbMaxVoisin;
        private int indiceS;
        private Logger log;

        public GRASP(Probleme un_probleme, int indiceC, int indiceS, int nbMaxVect, int nbMaxDeplacement, int nbMaxVoisin) {
            this.un_probleme = un_probleme;
            this.nbMaxVect=nbMaxVect;
            this.nbMaxDeplacement= nbMaxDeplacement;
            this.nbMaxVoisin=nbMaxVoisin;
            this.best_solution = new Solution(un_probleme);
            this.r=new Random();
            this.indiceC=indiceC;
            this.indiceS=indiceS;
        }
    
    
    
 // ajouter test arret si solution inferieure à solution espérée
    @Override
    public void run () {
	int i=0, j=0, k=0;
        int n = un_probleme.nbjob*un_probleme.nbmac;
	Solution une_solution = new Solution (un_probleme);
        Solution best_voisin = new Solution (un_probleme);
        Solution voisin = new Solution (un_probleme);
        Solution local_best = new Solution(un_probleme);
        int nbBrokenTL;
        
        int maxIter1 = this.nbMaxVect;
        int maxIter2 = this.nbMaxDeplacement;
        int maxIter3 = this.nbMaxVoisin;
        
        int hashTabSize = 999999;
        int[] hashTab = new int[hashTabSize];
        int hash = 0;
        for (int h = 0; h < hashTabSize; ++h) {
            hashTab[h]=0;
        }
	best_solution.cout = 999999999;	// on met le cout de la meilleure solution tres haut
        
        
	while (i<maxIter1 && !WebService_JSTL.saveResult[this.indiceC][this.indiceS].stop_Grasp) {
            generer_can_bierwirth(une_solution, un_probleme, r);
            evaluate(une_solution, un_probleme, 0, true);
            local_best.cout=9999999;
            
            j=0;
            while (j<maxIter2 && !WebService_JSTL.saveResult[this.indiceC][this.indiceS].stop_Grasp) {
                if (une_solution.cout < local_best.cout ) {
                    local_best.Copie(une_solution, un_probleme);
                    //j=0; Experiment - si on a amélioré la meilleure solution on s'autorise à explorer davantage l'espace des solutions
                }

                best_voisin.cout = 999999999;
                k=0;
                while (k<maxIter3 && !WebService_JSTL.saveResult[this.indiceC][this.indiceS].stop_Grasp) {
                    voisin = generer_voisin(une_solution , un_probleme, r);
                    
                    hash = hash_Sommets(voisin, un_probleme, 999999);
                    if (hashTab[hash]==0) {
                        hashTab[hash]=1;
                        
                        recherche_locale (voisin, un_probleme);  // recherche locale sur le voisin
                        hashTab[hash_Sommets(voisin, un_probleme, 999999)]=1;
                        
                        repairSolution(un_probleme, voisin, n);
                        hashTab[hash_Sommets(voisin, un_probleme, 999999)]=1;

                        if (voisin.cout < best_voisin.cout) { // si le cout est amelioré, on sauvegarde le voisin
                            best_voisin.Copie(voisin, un_probleme);
                            //k=0;  Experiment - si on a amélioré la meilleure solution on s'autorise à explorer davantage l'espace des voisins
                        }
                    }
                    ++k;
                }
                une_solution.Copie(best_voisin, un_probleme);
                ++j;
            }
            if (local_best.cout < best_solution.cout ) {
                best_solution.Copie(local_best, un_probleme);		// si la solution trouvée est meilleure que la best_solution, on la stock
            }
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].progress=++i;
	}
	
        if (WebService_JSTL.saveResult[this.indiceC][this.indiceS].stop_Grasp) {
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].erreur="algorithm stopped before end";
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].un_prob= un_probleme;
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].isResultOk=1; 
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].progress=maxIter1;
        } else {
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].un_prob= un_probleme;
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].isResultOk=1;
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].erreur="OK";
            WebService_JSTL.saveResult[this.indiceC][this.indiceS].progress=maxIter1;
        }
        WebService_JSTL.saveResult[this.indiceC][this.indiceS].sol= new Solution(this.best_solution, un_probleme);
    }
    
}
