/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package JSTL_WS_package;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;


public class Probleme {
   
    public int error;
    public String strError;
    public int itermax;
    public int nbjob;
    public int nbmac;
    public long biCriteria;
    public Operation liste_operation[][];
    public int machine[][];
    
    public Probleme() {
        this.error = 0;
        this.itermax=0;
        this.liste_operation=null;
        this.machine=null;
        this.biCriteria = 0;
        this.nbjob=0;
        this.nbmac=0;
        this.strError=null;
                
    }
    
    
     public Probleme (byte[] file, Logger log) {
        //lecture du fichier texte
        String[] mots = null ;
        int k = 0, job, mac;
        
        try{
            
            InputStream ips = new ByteArrayInputStream(file);
            InputStreamReader ipsr = new InputStreamReader(ips);
            BufferedReader br = new BufferedReader(ipsr);
            String ligne = br.readLine();
            
            
            mots = ligne.trim().split("\\s+") ;
            nbjob = Integer.parseInt(mots[0]);      //on stock le nombre de jobs
            nbmac = Integer.parseInt(mots[1]);      //on stock le nombre de machines
            itermax=(int)((nbjob*nbmac)/2)+5;
            liste_operation = new Operation[nbjob][nbmac];
            machine = new int [nbmac][nbjob];
            
            for( job = 0; job < nbjob; job++){
                mots = br.readLine().trim().split("\\s+");
                for (mac=0; mac<nbmac; ++mac) {
                    Operation une_operation = new Operation ();
                    une_operation.numero = Integer.parseInt(mots[2*mac]);                     // on stock le numero de la machine
                    une_operation.dureeHoriz = Integer.parseInt(mots[2*mac+1]);
                    une_operation.dureeDisj = une_operation.dureeHoriz;
                    une_operation.sommet = k++;                                             // on stock le numero de sommet correspondant dans le graphe
                    liste_operation[job][mac] = une_operation;
                    machine[liste_operation[job][mac].numero][job] = mac;   // on stock la position de la machine NUMERO dans la gamme du produit i
                }
            }
            mots = br.readLine().trim().split("\\s+"); // lecture du RES=
            for( job = 0; job < nbjob; job++){
                mots = br.readLine().trim().split("\\s+");
                if (job > 0) {
                    liste_operation[job][0].timelagmin = Integer.parseInt(mots[0]);
                } else {
                   String[] firstTL = mots[0].split("=");
                   liste_operation[job][0].timelagmin = Integer.parseInt(firstTL[1]);
                }
                liste_operation[job][0].dureeHoriz += liste_operation[job][0].timelagmin;
                liste_operation[job][0].timelagMax = Integer.parseInt(mots[1]);
                liste_operation[job][0].arcRetour = -(Integer.parseInt(mots[1])+liste_operation[job][0].dureeHoriz);
                for (mac=1; mac<nbmac; ++mac) {
                    liste_operation[job][mac].timelagmin = Integer.parseInt(mots[2*mac]);
                    // ajout du timeLag min a la durée globale de l'opération
                    liste_operation[job][mac].dureeHoriz += liste_operation[job][mac].timelagmin;
                    liste_operation[job][mac].timelagMax = Integer.parseInt(mots[2*mac+1]);
                    liste_operation[job][mac].arcRetour = -(Integer.parseInt(mots[2*mac+1])+liste_operation[job][mac].dureeHoriz);
                }
            }
            br.close();
            error = 0;
            strError = "No error occured during problem creation";
            // calcul de la pire solution
            long worstSol = 0;
            for (int i=0; i<nbjob; ++i) {
                for (int j=0; j<nbmac; ++j) {
                    worstSol+=liste_operation[i][j].dureeHoriz;
                }
            }
            
            int puissance=1;
            // calcul pour utilisation dans le nombre de TL brisés
            while (worstSol > puissance) puissance*=10;
            // on s'autorise un écart d'un zero pour bien différencier la partie gauche et droite du multicritère 
            biCriteria =puissance*10;
            
        } catch (Exception e) {
            log.log(Level.SEVERE, null, e);
            error = -1;
            strError = "Your file does not respect the format required";
        }
    }
     
}
